/*
File: LocalApplications.java
Date		Author		Changes
Sept 06 96	Lukasz Beca	Created

Tested:

Notes:

*/

package webwisdom.tango.structures;

import java.util.Hashtable;
import java.util.Enumeration;
import webwisdom.tango.structures.Handle;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.structures.CentralServer;
import webwisdom.tango.messages.EventMessage;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.messages.GroupEventMessage;
import webwisdom.tango.consts.Const;


public class LocalApplications {  //information about applications and applets connected to local demon
 
	
 
  private ControlApplication ca;
  private CentralServer cs;
  private Hashtable HandleTable;

  public LocalApplications() {
   
    HandleTable = new Hashtable();
   
  }

  //interface for LocalBase
  //initAssociations(ControlApplication ca, CentralServer cs);
  public void initAssociations(ControlApplication capar, CentralServer cspar) {

    ca = capar;
    cs = cspar;

  }
  
  //interface for registrar
  //public synchronized void addApplication(Handle h, int a);

  public synchronized void addApplication(Handle h, int a, int s) { //h - handle to application or applet
  //a - AID

    Integer b;
    boolean added;   

    if (a == 0) {
      System.out.println("LocalApplications: cannot add application with AID = 0");
      return;
    } 
    
    b = new Integer(a);     
    added = HandleTable.containsKey(b);
       
    if (!added) {
      
      try {

	HandleTable.put(b, h);

      } catch(Exception e) {

	System.out.println("LocalApplications: handle parameter invalid, cannot add" + e);	
					e.printStackTrace();

      }

      cs.started(a, s);
    }
    else
      System.out.println("LocalAppliations: application already added, cannot add"); 
              
  }

  //interface for application Handles
  //public void terminated(int AID);
  //public void sendAppToOther(int AID, AppEventMessage m);
  //public void sendAppToOther(int AID, int userlist[], AppEventMessage m);

  public void terminated(int AID) {

    Integer AIDtmp = new Integer(AID);

    ca.removeApplication(AID);
    HandleTable.remove(AIDtmp);
    
  }
  public void sendAppToOther(int AID, AppEventMessage m) {

    int type = m.getType();
    byte data[] = m.getData();
    EventMessage a;

    switch(type) {

      case Const.DATA:
				a = new EventMessage(AID, data);
				cs.sendLAToCS(a);
				break;

      case Const.CONTROL:
				ca.sendLAToCAB(AID, m);
				break;
	
      default:
				System.out.println("LocalApplications: type of message " + type + " not implemented");
    }

  }
  
  public void sendAppToOther(int AID, int userlist[], AppEventMessage m) {

    int type = m.getType();
    byte data[] = m.getData();
    GroupEventMessage a;

    if (type == Const.DATA) {

  			a = new GroupEventMessage(AID, userlist, data);
			cs.sendLAToCS(a);
		
    }
  }

  //interface for ControlApplication
  //public synchronized boolean appInSession(int AIDpar);
  //public synchronized void finish(int AIDpar);
  //public synchronized void finishAll();
  //public void setFocus(int AIDpar);
  //public void sendCAtoApp(int AID, AppEventMessage m);
  //public void end();

  public synchronized boolean appInSession(int AIDpar) {

    Integer AID = new Integer(AIDpar);
   
    return HandleTable.containsKey(AID);
    
  }

   public synchronized void finish(int AIDpar) {

    Integer AID = new Integer(AIDpar);    
    Handle h;
   
    h = (Handle) HandleTable.remove(AID);
    System.out.println("LocalApplication: application " + AID + " removed from tabe");

    if (h != null) { 
      h.finish();    
      System.out.println("LocalApplication: application " + AID + " finished");
    }
    else
     	System.out.println("LocalApplications: application " + AID + " does not exist, cannot finish");
     
  }

  public synchronized void finishAll(){

    Handle h;
    Integer key;
    int i, size;
    Enumeration e;

    e = HandleTable.keys();
   
    System.out.println("LocalApplication: terminating all applications");

    while(e.hasMoreElements()) {

      key = (Integer) e.nextElement();      
      h = (Handle) HandleTable.remove(key);
      h.finish();

    }
    
  }


  public void setFocus(int AIDpar) {

    Integer AID = new Integer(AIDpar);   
    Handle h;  

    h = (Handle) HandleTable.get(AID);

    if (h != null) {
    
      h.setFocus();

    }
    else
     	System.out.println("LocalApplications: application " + AID + " does not exist, cannot set focus");

  }

  public void sendCAToApp(int AID, AppEventMessage m) {
  
    Integer AIDtmp;
    Handle h;
   
    AIDtmp = new Integer(AID);
   
    h = (Handle) HandleTable.get(AIDtmp);

    if (h != null) {

	h.sendLAToApp(m);

    }     
      else
      	System.out.println("LocalApplications: application " + AID + " does not exist, cannot send ");

    
  }

  public void end() {

    ca = null;
    cs = null;
    HandleTable = null;

  }

  //interface for CentralServer
  //public void sendCStoApp(EventMessage m)


   public void sendCSToApp(EventMessage m) {
   
    int AID = m.getAID();
    byte data[] = m.getData();
    AppEventMessage appm;
    Integer AIDtmp;
    Handle h;

   
    AIDtmp = new Integer(AID);
  
    h = (Handle) HandleTable.get(AIDtmp);

    if (h != null) {
	
	appm = new AppEventMessage(Const.DATA, data);
	h.sendLAToApp(appm);

    }     
      else
      	System.out.println("LocalApplications: application " + AID + " does not exist, cannot send ");

    
  }

  
  //diagnostic methods
  //public void list();

  public void list() {

    // int i;    
    Enumeration e;

    e = HandleTable.keys();

    while(e.hasMoreElements()) {
            
       System.out.println("AID " + e.nextElement());
    }
  }
			  
}



